import { GraphQLFieldConfigMap } from "graphql";
import { Field, ClassType, StringKeyOf, InstanceOf, FieldType, Removable, Args } from "../../../..";
import { GQLType } from "../GQLType";
import { ResolveFunction, KeyValue } from "../../../../types";
export declare abstract class GQLObjectType<BuiltType = any, T extends ClassType<any> = any> extends GQLType<BuiltType, T> {
    protected _fields: Field<StringKeyOf<InstanceOf<T>>>[];
    get fields(): Field<StringKeyOf<InstanceOf<T>>>[];
    constructor(name: string);
    /**
     * Add a single field to the fields list
     * @param name The field name
     * @param type The field type
     */
    addField<ReturnType = any, ArgType = KeyValue>(name: StringKeyOf<InstanceOf<T>>, type: FieldType, resolver?: ResolveFunction<ReturnType, ArgType>, args?: Args<ClassType<ArgType>>): any;
    setFields(...fields: Field<StringKeyOf<InstanceOf<T>>>[]): this;
    addFields(...fields: Field<StringKeyOf<InstanceOf<T>>>[]): this;
    removeFields(...fields: Removable<Field<StringKeyOf<InstanceOf<T>>>>): this;
    transformFields(cb: (field: Field) => void): this;
    protected getFields(): GraphQLFieldConfigMap<any, any>;
}
